import request from "../utils/request";

/** 获取学生信息 */
export const studentQueryUserInfo = async () => {
	return await request.get(`/student/queryUserInfo`);
};
/** 获取老师信息 */
export const teacherQueryUserInfo = () => {
	return request.get(`/teacher/queryUserInfo`);
};
/** 后台用户信息 */
export const employeeQueryUserInfo = () => {
	return request.get(`/employee/queryUserInfo`);
};

/** 获取曲谱信息 */
export const sysMusicScoreAccompanimentQueryPage = (sysMusicScoreId: string) => {
	return request.get("/sysMusicScoreAccompaniment/queryPage", {
		params: {
			clientType: "SMART_PRACTICE",
			sysMusicScoreId,
		},
	});
};

/** 获取曲谱分类 */
export const sysMusicScoreCategoriesQueryTree = (enable = false) => {
	return request.get(`/sysMusicScoreCategories/queryTree`, {
		params: {
			parentId: 0,
			// 后台详情忽略是否启用分类
			enable,
		},
	});
};

/** 获取曲谱列表 */
export const sysMusicScoreQueryPage2 = (params: any) => {
	return request.get(`/sysMusicScore/queryPage2`, { params });
};

/** 提交意见反馈 */
export const suggestionAdd = (data: any) => {
	return request.post("/suggestion/add", { data });
};

/** 记录训练时长 */
export const sysMusicRecordAdd = (data: any) => {
	return request.post("/sysMusicRecord/add", { data });
};
/** 获取训练时长 */
export const tempLittleArtistTrainingCampGetUserTrainingTime = () => {
	return request.post("/tempLittleArtistTrainingCamp/getUserTrainingTime");
};
/** 添加作业记录 */
export const studentCourseHomeworkAddStudentHomeworkRecord = (params: any) => {
	return request.get("/studentCourseHomework/addStudentHomeworkRecord", { params });
};
/** 获取作业详情 */
export const studentCourseHomeworkHomeworkDetail = (id: any) => {
	return request.get(`/studentCourseHomework/homeworkDetail?id=${id}`);
};
/** 获取进度详情 */
export const lessonExaminationGetDetail = (params: any) => {
	return request.get(`/lessonExamination/getDetail`, { params });
};
/** 添加进度评测记录 */
export const lessonExaminationSubmit = (data: any) => {
	return request.post(`/lessonExamination/submit`, { data, requestType: 'form' });
};
